#include <conio.h>
#include <dos.h>
#include <mem.h>

#include "modex.h"

#define ATTRCON_ADDR    0x3C0
#define MISC_ADDR       0x3C2
#define VGAENABLE_ADDR  0x3C3
#define SEQU_ADDR       0x3C4
#define GRACON_ADDR     0x3CE
#define CRTC_ADDR       0x3D4
#define STATUS_ADDR     0x3DA


unsigned short ModeX_256x224regs[22*3] =
{
    0x3c2, 0x00, 0xe3,
    0x3d4, 0x00, 0x5f,
    0x3d4, 0x01, 0x3f,
    0x3d4, 0x02, 0x40,
    0x3d4, 0x03, 0x82,
    0x3d4, 0x04, 0x4a,
    0x3d4, 0x05, 0x9a,
    0x3d4, 0x06, 0x0b,
    0x3d4, 0x07, 0x3e,
    0x3d4, 0x08, 0x00,
    0x3d4, 0x09, 0x41,
    0x3d4, 0x10, 0xda,
    0x3d4, 0x11, 0x9c,
    0x3d4, 0x12, 0xbf,
    0x3d4, 0x13, 0x20,
//    0x3d4, 0x14, 0x00,
    0x3d4, 0x15, 0xc7,
    0x3d4, 0x16, 0x04,
//    0x3d4, 0x17, 0xe3,
    0x3c4, 0x01, 0x01,
//    0x3c4, 0x04, 0x06,
    0x3ce, 0x05, 0x40,
    0x3ce, 0x06, 0x05,
    0x3c0, 0x10, 0x41,
    0x3c0, 0x13, 0x00
};


//    setBaseXMode() does the initialization to make the VGA ready to
//    accept any combination of configuration register settings.  This
//    involves enabling writes to index 0 to 7 of the CRT controller (port
//    0x3D4), by clearing the most significant bit (bit 7) of index 0x11.
void setBaseXMode(void)
{
    int temp;
    union REGS r;

    r.x.eax = 0x0013;
    int386(0x10, &r, &r);

    outp(0x3D4, 0x11);
    temp = inp(0x3D5) & 0x7F;
    outp(0x3D4, 0x11);
    outp(0x3D5, temp);
}


void outReg(unsigned short *r)
{
    switch (r[0]) {
        // First handle special cases:

                case ATTRCON_ADDR:
            // reset read/write flip-flop
            inp(STATUS_ADDR);
            outp(ATTRCON_ADDR, r[1] | 0x20);
            // ensure VGA output is enabled
            outp(ATTRCON_ADDR, r[2]);
                        break;

                case MISC_ADDR:
                case VGAENABLE_ADDR:
            // Copy directly to port
            outp(r[0], r[2]);
                        break;

        case SEQU_ADDR:
                case GRACON_ADDR:
                case CRTC_ADDR:
        default:
            // Index to port
            outp(r[0], r[1]);
            // Value to port+1
            outp(r[0] + 1, r[2]);
                        break;
    }
}

void
outRegArray(unsigned short *r, int n)
{
    while (n--) {
        outReg(r);
        r += 3;
    }
}


void
set256x224x256_X(void)
{
    setBaseXMode();
    outRegArray(ModeX_256x224regs, 22);
}


