#ifndef _MMC_
#define _MMC_

//memory mapper types
#define MMC_NONE   0
#define MMC_SEQ    1
#define MMC_KONAMI 2
#define MMC_VROMSWITCH 3
#define MMC_5202   4


//32K rombank representing a possible rom combination
struct ROMBANK
{
 char s[0x8000];

 void setlowpage(ROMPAGE *p); //set low page
 void sethighpage(ROMPAGE *p); //set high page
};

//class for memory mapper chip
class memorymapper
{
 public:
 memorymapper() {}
 virtual ~memorymapper() {};
 virtual void reset() {}; //reset
 virtual int write(word a,byte d) {return 0;}; //ROM write (return 1 if bank switch)
 virtual byte ppuread(word a)=0; //ppu memory read (for vrom)

 virtual void doVROMswitch() {} //called before VROM is used for drawing

 virtual int keyhit(char kbscan,char key) {return 0;}
};

memorymapper *newmemorymapper(int type);

extern memorymapper *mmc;

char *getmmctypestr(int type);

#endif
