//routines for intepreting split screens and the like
#include <stdlib.h>

#include "nes.h"
#include "nesvideo.h"
#include "message.h"
#include "slist.h"
#include "mmc.h"

#include "r2img.h"
#include "font.h"
#include "dd.h"

#include "m6502.h"



void sevent::print(int x,int y)
{
 switch (type)
 {
  case SE_NATABLE: font[1]->printf(x,y,"line=%d natable=%d %X",line,data,t[0]); break; //t[0],pc); break;
  case SE_SCROLLX: font[1]->printf(x,y,"line=%d scrollx=%d %X",line,data,t[0]); break; //t[0],pc); break;
  case SE_SCROLLY: font[1]->printf(x,y,"line=%d scrolly=%d %X",line,data,t[0]); break; //t[0],pc); break;
  case SE_SPRITE:  font[1]->printf(x,y,"line=%d sprites=%s",line,data ? "on" : "off"); break; //t[0],pc); break;
  case SE_HITFLAG:  font[2]->printf(x,y,"line=%d hitflag read",line); break; //t[0],pc); break;
  case SE_FRAMESTART:  font[2]->printf(x,y,"line=%d vframe start",line); break; //t[0],pc); break;
  case SE_PTABLE: font[1]->printf(x,y,"line=%d ptable=%d",line,data); break; //t[0],pc); break;
 }
}

void seventlist::print(int x,int y)
{
 for (int i=0; i<num; i++,y+=10)
   s[i].print(x,y);
}

int getvblankscanline();
extern byte hitflag;
extern byte num2002read;
void seventlist::add(sevent &t)
 {
  if (num>0 && s[num-1]==t) return;
  if (num>511) return;
  t.line=getscanline();
//  t.line=min(getscanline(),((int)spritemem[0].y)-1);
//  t.line+=4;
  //if (ram[0x2000]&32)
 t.line+=3;
 t.line&=~7;
  t.t[0]=ram[0x2000]; //num2002read;
//  t.t[1]=hitflag; //getvblankscanline(); //
//  t.pc=m6502pc;
// t.pc=0; //m6502lastjsr;
  s[num++]=t;
 } //add event



//integrate event into screen context
void scontext::operator +=(sevent &e)
{
 switch (e.type)
  {
   case SE_NATABLE: natable=e.data; break;
   case SE_SCROLLX: sx=e.data; break;
   case SE_SCROLLY: sy=e.data; break;
   case SE_SPRITE: sprites=e.data ? 1 : 0; break;
   case SE_PTABLE: pt=e.data ? 1 : 0; break;
  }
 line=e.line;
// msg.printf(2,"%d",line);
}

void scontextlist::add(scontext &t)
{
 if (scnum>0 && t==sc[scnum-1]) return; //dont add if last was the same
 sc[scnum++]=t;

}

//create contexts list from eventlist
void scontextlist::create(seventlist &el)
{
 scnum=0;

 //create first context
// c.sprites=1; //force sprites on
 c.setline(0);    //top of screen
// add(c);      //add it

 for (int i=0; i<el.num; i++) //process all events
   if (el.s[i].line<=c.line+1) c+=el.s[i]; //does event apply to current context?
     else
     {
      add(c); //add current context to list
      c.setline(el.s[i].line); //start context at new line
      c+=el.s[i];      //integrate event
     }
 add(c);

 //add screen height to end
 sc[scnum].line=nv->yw;

 //resolve all heights
 for (i=0; i<scnum; i++)
  sc[i].setheight(sc[i+1].line);

 //set default for next time
 c=sc[scnum-1];
}


void scontext::print(int x,int y)
{
 font[1]->printf(x,y,"line=%d ht=%d scroll=%d,%d na=%d sp=%d pt=%d",line,height,sx,sy,natable,sprites,pt);
}


void scontextlist::print(int x,int y)
{
 for (int i=0; i<scnum; i++,y+=10)
  sc[i].print(x,y);
}

















