//routines for intepreting split screens and the like
#include <stdlib.h>

#include "nes.h"
#include "nesvideo.h"
#include "message.h"
#include "slist.h"
#include "mmc.h"

#include "r2img.h"
#include "font.h"
#include "dd.h"

#include "m6502.h"



void sevent::print(int x,int y)
{
 switch (type)
 {
  case SE_NATABLE: font[0]->printf(x,y,"line=%d natable=%d %X %X",line,data,0,0); break; //t[0],pc); break;
  case SE_SCROLLX: font[0]->printf(x,y,"line=%d scrollx=%d %X %X",line,data,0,0); break; //t[0],pc); break;
  case SE_SCROLLY: font[0]->printf(x,y,"line=%d scrolly=%d %X %X",line,data,0,0); break; //t[0],pc); break;
  case SE_SPRITE:  font[0]->printf(x,y,"line=%d sprites=%d",line,data); break; //t[0],pc); break;
 }
}

void seventlist::print(int x,int y)
{
 for (int i=0; i<num; i++,y+=10)
   s[i].print(x,y);
}

int getvblankscanline();
extern byte hitflag;
void seventlist::add(sevent &t)
 {
  if (num>0 && s[num-1]==t) return;
  if (num>511) return;
  t.line=min(getscanline(),spritemem[0].y+8);
//  t.line+=1;
//  t.line&=~7;

//  t.t[0]=ram[0xFF]; //mmc->getbank(); //ram[0x2000];
//  t.t[1]=hitflag; //getvblankscanline(); //
//  t.pc=m6502pc;
  s[num++]=t;
 } //add event



//integrate event into screen context
void scontext::operator +=(sevent &e)
{
 switch (e.type)
  {
   case SE_NATABLE: natable=e.data; break;
   case SE_SCROLLX: sx=e.data; break;
   case SE_SCROLLY: sy=e.data; break;
   case SE_SPRITE: sprites=e.data ? 1 : 0; break;
  }
// line=(e.line);
}

void scontextlist::add(scontext &t)
{
 if (scnum>0 && t==sc[scnum-1]) return; //dont add if last was the same
 sc[scnum++]=t;

}

//create contexts list from eventlist
void scontextlist::create(seventlist &el)
{
 scnum=0;

 //create first context
 c.sprites=1; //force sprites on
 c.setline(8);    //top of screen
// add(c);      //add it

 for (int i=0; i<el.num; i++) //process all events
   if (el.s[i].line<=c.line+8) c+=el.s[i]; //does event apply to current context?
     else
     {
      add(c); //add current context to list
      c.setline(el.s[i].line); //start context at new line
      c+=el.s[i];      //integrate event
     }
 add(c);

 //add screen height to end
 sc[scnum].line=232;

 //resolve all heights
 for (i=0; i<scnum; i++)
  sc[i].setheight(sc[i+1].line);

 //set default for next time
 c=sc[scnum-1];
}


void scontext::print(int x,int y)
{
 font[1]->printf(x,y,"line=%d height=%d scroll=%d,%d na=%d sp=%d",line,height,sx,sy,natable,sprites);
}


void scontextlist::print(int x,int y)
{
 for (int i=0; i<scnum; i++,y+=10)
  sc[i].print(x,y);
}

















